---------- GTA IV Alice "GarageMod" script ----------
	---------- Majority of code  GAK 2008 ----------

--global variables
PLAYER_ID, PLAYER_INDEX, PLAYER_CHAR, PLAYER_CAR, SAVED_CAR, HLIGHT, ILIGHT = 0

function InitScript()
	-- blah-blah-blah
	Wait(10000)
end

function WaitForPlayerPoolCreation()
	while (IsPlayerPoolCreated() == 0) do
		Wait(2000)
	end
end

function WaitForValidPlayer()
	PLAYER_CHAR = 0
	repeat
		CallNative("GET_PLAYER_ID")
		PLAYER_ID = GetIntResult()
		if (PLAYER_ID >= 0) then
		PushInt(PLAYER_ID)
		CallNative("CONVERT_INT_TO_PLAYERINDEX")
		PLAYER_INDEX = GetIntResult()
		PushInt(PLAYER_INDEX)
		PushVarPtr()
		CallNative("GET_PLAYER_CHAR")
		PLAYER_CHAR = GetIntParam(1)
		if (PLAYER_CHAR <= 0) then
			Wait(1000)
		end
		end
	until (PLAYER_CHAR > 0)
end

----------------------------MAIN FUNCTION----------------------------
function CarExist(Car)
	PushInt(Car)
	CallNative("DOES_VEHICLE_EXIST")
	return GetIntResult()
end

function CarIsSaved()
	local retu=0
	if (SAVED_CAR ~= 0) then
		--Check if the car is still
		if (CarExist(SAVED_CAR) == 1) then
			retu=1
		else
			SAVED_CAR=0
			retu=0
		end
	else
		retu=0
	end
	return retu
end

function PlayerIsInCar()
	PushInt(PLAYER_CHAR)
	CallNative("IS_CHAR_SITTING_IN_ANY_CAR")
	return GetIntResult()
end

function Bip(num)
	--Emulates a beep
	PushInt(num)
	CallNative("PREVIEW_RINGTONE")
	Wait(70)
	CallNative("STOP_PREVIEW_RINGTONE")
end

function GetPavNumKey()
	--Return PavNumKey was pressed
	local i=0
	local re=10
	while (i<=9) do
		if (IsKeyPressed(i + 96) == 1) then
			re=i
		end
		i=i+1
	end
	return re
end

function WaitForKeyUp(KeyCod)
	while (IsKeyPressed(KeyCod) == 1) do
		Wait(200)
	end
end

function WaitForPavNumKey(CancelKey)
	--Wait until PavNumKey is pressed and return its value unless CancelKey is pressed
	local PavKey=10
	while (PavKey>=10 and IsKeyPressed(CancelKey) == 0) do
		PavKey=GetPavNumKey()
		Wait(100)
	end
	Bip(1)
	if (PavKey < 10) then WaitForKeyUp(PavKey+96) else WaitForKeyUp(CancelKey) end
	return PavKey
end

function WaitForValue(Size, CancKey)
	local z=0
	local ret=0
	local cancl=0
	local val=0

	--Get a number of defined size
	while (z<Size and cancl == 0) do
		val=WaitForPavNumKey(CancKey)
		ret=(ret*10)+val

		--Check if the player cancels
		if (val >= 10) then
			cancl=1
			ret=-1
		end
		z=z+1
	end
	return ret
end

function GetPlayerCar()
	--Check if player wants to change the car he has saved or not
	if (CarIsSaved() == 1 and PlayerIsInCar() == 0) then
		PLAYER_CAR=SAVED_CAR
	else
		PushInt(PLAYER_CHAR)
		PushVarPtr()
		CallNative("GET_CAR_CHAR_IS_USING")
		PLAYER_CAR = GetIntParam(1)
	end
end

function GetCarColors(ColNum)
	--Check if it's a normal color or a "special" color
	if (ColNum <= 2) then
		PushInt(PLAYER_CAR)
		PushVarPtr()
		PushVarPtr()
		CallNative("GET_CAR_COLOURS")
		return GetIntParam(ColNum)
	else
		PushInt(PLAYER_CAR)
		PushVarPtr()
		PushVarPtr()
		CallNative("GET_EXTRA_CAR_COLOURS")
		return GetIntParam(ColNum - 2)
	end
end

function ScreenFade(Time)
	PushInt(Time)
	CallNative("DO_SCREEN_FADE_OUT")
	Wait(Time)
	PushInt(Time)
	CallNative("DO_SCREEN_FADE_IN")
end

----------------------------MENU FUNCTION----------------------------
function ChgCarColor(ColorNum, ColorVal)
	local color=0

	--Check if the player cancels and if ColorVal is not too large
	if (ColorVal <= -1) then
		ColorNum=0
		ScreenFade(250)
	elseif (ColorVal > 133) then
		ColorVal=133
	end

	-- 1 and 2 is normal color and 3 and 4 is "special" color or specular color
	if (ColorNum == 1) then
		color=GetCarColors(2)
		PushInt(PLAYER_CAR)
		PushInt(ColorVal)
		PushInt(color)
		CallNative("CHANGE_CAR_COLOUR")
	elseif (ColorNum == 2) then
		color=GetCarColors(1)
		PushInt(PLAYER_CAR)
		PushInt(color)
		PushInt(ColorVal)
		CallNative("CHANGE_CAR_COLOUR")
	elseif (ColorNum == 3) then
		color=GetCarColors(4)
		PushInt(PLAYER_CAR)
		PushInt(ColorVal)
		PushInt(color)
		CallNative("SET_EXTRA_CAR_COLOURS")
	elseif (ColorNum == 4) then
		color=GetCarColors(3)
		PushInt(PLAYER_CAR)
		PushInt(color)
		PushInt(ColorVal)
		CallNative("SET_EXTRA_CAR_COLOURS")
	end
end

function RemoveCarWindow(WinNum)

	--Window 0=left front 1=right front 2=left rear 3=right rear
	if (WinNum == 1) then
		PushInt(PLAYER_CAR)
		PushInt(WinNum-1)
		CallNative("REMOVE_CAR_WINDOW")
	elseif (WinNum == 2) then
		PushInt(PLAYER_CAR)
		PushInt(WinNum-1)
		CallNative("REMOVE_CAR_WINDOW")
	elseif (WinNum == 3) then
		PushInt(PLAYER_CAR)
		PushInt(WinNum-1)
		CallNative("REMOVE_CAR_WINDOW")
	elseif (WinNum == 4) then
		PushInt(PLAYER_CAR)
		PushInt(WinNum-1)
		CallNative("REMOVE_CAR_WINDOW")
	elseif (WinNum == 5) then
		local x=0
		while (x<=3) do
			PushInt(PLAYER_CAR)
			PushInt(x)
			CallNative("REMOVE_CAR_WINDOW")
			x=x+1
			Wait(100)
		end
	end

end

function RepairCar()
	PushInt(PLAYER_CAR)
	CallNative("FIX_CAR")
end

function WashCar()
	PushInt(PLAYER_CAR)
	PushFloat(0.0)
	CallNative("SET_VEHICLE_DIRT_LEVEL")
	PushInt(PLAYER_CAR)
	PushInt(255)
	CallNative("WASH_VEHICLE_TEXTURES")
end

function InvincibleCar()
	PushInt(PLAYER_CAR)
	PushInt(0)
	CallNative("SET_CAR_CAN_BE_DAMAGED")
	PushInt(PLAYER_CAR)
	PushInt(0)
	CallNative("SET_CAR_CAN_BE_VISIBLY_DAMAGED")
end

function ExplodeCar()
	if (CarIsSaved() == 1) then
		Wait(1000)
		PushInt(SAVED_CAR)
		PushInt(1)
		PushInt(1)
		CallNative("EXPLODE_CAR")
	else
		ScreenFade(250)
	end
end

function OpenCarDoor(ODoor)
	--Check if the player cancels
	if (ODoor >= 10) then
		ScreenFade(250)
	else
	--if (ODoor < 6) then
	PushInt(PLAYER_CAR)
	PushInt(ODoor)
	CallNative("OPEN_CAR_DOOR")
	--end
	end
end

function CloseCarDoor(CDoor)
	--Check if the player cancels
	if (CDoor >= 10) then
		ScreenFade(250)
	else
	--if (ODoor < 6) then
	PushInt(PLAYER_CAR)
	PushInt(CDoor)
	CallNative("SHUT_CAR_DOOR")
	--end
	end
end

function TelToCar(Place)
	if (CarIsSaved() == 1) then
		if (Place == 1) then
			Wait(500)
			PushInt(PLAYER_CHAR)
			PushInt(SAVED_CAR)
			CallNative("WARP_CHAR_INTO_CAR")
		else
			Wait(500)
			PushInt(PLAYER_CHAR)
			PushInt(SAVED_CAR)
			CallNative("WARP_CHAR_INTO_CAR_AS_PASSENGER")
		end
	else
		ScreenFade(250)
	end
end

function HazardLights()
	--Trigger hazard lights
	if (HLIGHT == 1) then
		HLIGHT=0
	else
		HLIGHT=1
	end

	PushInt(PLAYER_CAR)
	PushInt(HLIGHT)
	CallNative("SET_VEH_HAZARDLIGHTS")
end

function InteriorLight()
	--Trigger interior light
	if (ILIGHT == 1) then
		ILIGHT=0
	else
		ILIGHT=1
	end

	PushInt(PLAYER_CAR)
	PushInt(ILIGHT)
	CallNative("SET_VEH_INTERIORLIGHT")
end

----------------------------MENUS----------------------------
function SaveCar(CCar)
	SAVED_CAR = CCar
	PrintStrToLog("SaveCar")
	Bip(4)
end

function MenuColors(KeyNum)
	PrintStrToLog("MenuColors")
	PrintFloatToLog(KeyNum)
	GetPlayerCar()

	--Check if the player cancels and if not change the color of his car
	if (KeyNum >= 10 or KeyNum <= 0) then
		ScreenFade(250)
	elseif (KeyNum > 0) then
		ChgCarColor(KeyNum,WaitForValue(3,120))
	end

	--Signal the end
	Bip(4)
end

function MenuOthers(KeyNum)
	PrintStrToLog("MenuOthers")
	PrintFloatToLog(KeyNum)
	GetPlayerCar()

	--Check if the player cancels and if not remove the window of his car
	if (KeyNum >= 10 or KeyNum <= 0) then
		ScreenFade(250)
	elseif (KeyNum > 0) then
		RemoveCarWindow(KeyNum)
	end

	--Signal the end
	Bip(4)
end

function MenuRepairs(KeyNum)
	PrintStrToLog("MenuRepairs")
	PrintFloatToLog(KeyNum)
	GetPlayerCar()

	--Check if the player cancels and if not do what he wants
	if (KeyNum >= 10 or KeyNum <= 0) then
		ScreenFade(250)
	elseif (KeyNum == 1) then
		RepairCar()
	elseif (KeyNum == 2) then
		WashCar()
	elseif (KeyNum == 3) then
		InvincibleCar()
	elseif (KeyNum == 4 and CarIsSaved() == 1) then
		ExplodeCar()
	end

	--Signal the end
	Bip(4)
end

function MenuExtras(KeyNum)
	PrintStrToLog("MenuExtras")
	PrintFloatToLog(KeyNum)
	GetPlayerCar()

	--Check if the player cancels and if not do what he wants
	if (KeyNum >= 10 or KeyNum <= 0) then
		ScreenFade(250)
	elseif (KeyNum == 1) then
		OpenCarDoor(WaitForPavNumKey(123))
	elseif (KeyNum == 2) then
		CloseCarDoor(WaitForPavNumKey(123))
	elseif (KeyNum == 3) then
		TelToCar(1)
	elseif (KeyNum == 4) then
		TelToCar(2)
	elseif (KeyNum == 5) then
		HazardLights()
	elseif (KeyNum == 6) then
		InteriorLight()
	end

	--Signal the end
	Bip(4)
end

----------------------------MAIN----------------------------
function main()
	InitScript()

	--Infinite loop to check the keys
	while true do

		--Save his car(F8)
		if (IsKeyPressed(119) == 1) then
			--Check if the game is started
			WaitForPlayerPoolCreation()
			WaitForValidPlayer()

			--Check if player is in car
			if (PlayerIsInCar() == 1) then
				Bip(0)

				--Wait until key is Up(if not wait the code runs many times)
				WaitForKeyUp(119)
				GetPlayerCar()
				SaveCar(PLAYER_CAR)
				Wait(1000)
			end
		end

		--Menu Color changes(F9)
		if (IsKeyPressed(120) == 1) then
			--Check if the game is started
			WaitForPlayerPoolCreation()
			WaitForValidPlayer()

			--Check if player is in car or if he had saved a car
			if (PlayerIsInCar() == 1 or CarIsSaved() == 1) then
				Bip(0)

				--Wait until key is Up(if not wait the code runs many times)
				WaitForKeyUp(120)
				MenuColors(WaitForPavNumKey(120))
				Wait(1000)
			end
		end

		--Menu Others changes(F10)
		if (IsKeyPressed(121) == 1) then
			--Check if the game is started
			WaitForPlayerPoolCreation()
			WaitForValidPlayer()

			--Check if player is in car or if he had saved a car
			if (PlayerIsInCar() == 1 or CarIsSaved() == 1) then
				Bip(0)

				--Wait until key is Up(if not wait the code runs many times)
				WaitForKeyUp(121)
				MenuOthers(WaitForPavNumKey(121))
				Wait(1000)
			end
		end

		--Menu Repairs(F11)
		if (IsKeyPressed(122) == 1) then
			--Check if the game is started
			WaitForPlayerPoolCreation()
			WaitForValidPlayer()

			--Check if player is in car or if he had saved a car
			if (PlayerIsInCar() == 1 or CarIsSaved() == 1) then
				Bip(0)

				--Wait until key is Up(if not wait the code runs many times)
				WaitForKeyUp(122)
				MenuRepairs(WaitForPavNumKey(122))
				Wait(1000)
			end
		end

		--Menu Extras(F12)
		if (IsKeyPressed(123) == 1) then
			--Check if the game is started
			WaitForPlayerPoolCreation()
			WaitForValidPlayer()

			--Check if player is in car or if he had saved a car
			if (PlayerIsInCar() == 1 or CarIsSaved() == 1) then
				Bip(0)

				--Wait until key is Up(if not wait the code runs many times)
				WaitForKeyUp(123)
				MenuExtras(WaitForPavNumKey(123))
				Wait(1000)
			end
		end
		Wait(200)
	end

end

-- start
main();



